#! /usr/bin/env python

#######################################
# An python class to parse a comma 
# separates text file to calculate 
# the mean and standard deviation 
# of the inputted floating point
# numbers.
# Author: <YOUR NAME>
# Email: <YOUR EMAIL>
# Date: DD/MM/YYYY
# Version: 1.0
#######################################

# import the squareroot function from python math
from math import sqrt

# Define a new class called CalcMeanStdDev
class CalcMeanStdDev (object):
    
    # Define a function which parses a comma
    # separated file - you should understand 
    # the contents of this script from the 
    # previous examples.
    # Note: the file is passed into the 
    # function.
    def parseCommaFile(self, file):
        floatingNumbers = list()
        for eachLine in file:
            substrs = eachLine.split(',',eachLine.count(','))
            for strVar in substrs:
                floatingNumbers.append(float(strVar))
        return floatingNumbers

    # Define a function to calculate the mean
    # value from a list of numbers.
    # Note. The list of numbers is passed into
    # the function.
    def calcMean(self, numbers):
        # A variable to sum all the numbers
        sum = 0.0
        # Iterate through the numbers list
        for number in numbers:
            # add each number to the sum
            sum += number
        # Divide the sum by the number of 
        # values within the numbers list
        # (i.e., its length)
        mean = sum/len(numbers)
        # return the mean value calculated
        return mean
        
    # Define a function which calculates the
    # standard deviation of a list of numbers
    # Note. The list of numbers is passed into 
    # the function alongside a previously 
    # calculated mean value for the list.
    def calcStdDev(self, numbers, mean):
        # Varible for total deviation
        deviation = 0.0
        # Variable for a single deviation
        singleDev = 0.0
        # Iterate through the list of numbers.
        for number in numbers:
            # Calculate a single Deviation
            singleDev = number-mean
            # Add the squared single deviation to 
            # to the on going total.
            deviation += (singleDev**2)
        # Calcate the standard devaition
        stddev = sqrt(deviation/(len(numbers)-1))
        # return the standard deviation
        return stddev

    # The main thread of processing. A function
    # which defines the order of processing.
    # Note. The filename is passed in.
    def run(self, filename):
        # Open the input file
        inFile = open(filename, 'r')
        # Parse the file to retrieve a list of
        # numbers
        numbers = self.parseCommaFile(inFile)
        
        # Calculate the mean value of the list
        mean = self.calcMean(numbers)
        # Calculate the standard deviation of the 
        # list.
        stddev = self.calcStdDev(numbers, mean)
        
        # Print the results to screen
        print 'Mean: ' + str(mean)
        print 'Stddev: ' + str(stddev)
        
        # Close the input file
        inFile.close()
         
# When python is executed python executes 
# the code with the lowest indentation first. 
#
# We can identify when python is executed from
# the command line using the following if statment.
#
# When executed we want the run() function to be 
# executed therefore we create a CalcMeanStdDev
# object and call run on that object - passing
# in the file name of the file to be processed.
if __name__ == '__main__':
    obj = CalcMeanStdDev()
    obj.run('randfloats.txt') # Update with full file path.
