#######################################
# A python script to read in a text file
# of rainfall data for summer and winter
# within the UK and display as a plot.
# Author: <YOUR NAME>
# Email: <YOUR EMAIL>
# Date: DD/MM/YYYY
# Version: 1.0
#######################################

from pylab import *
import os.path
import sys

class PlotRainfall (object):
    
    # Parse the input file - Three columns year, summer, winter
    def parseDataFile(self, dataFile, year, summer, winter):
        line = 0
        for eachLine in dataFile:
            commaSplit = eachLine.split(',', eachLine.count(','))
            first = True
            for token in commaSplit:
                if first:
                    first = False
                else:
                    if line == 0:
                        year.append(int(token))
                    elif line == 1:
                        summer.append(float(token))
                    elif line == 2:
                        winter.append(float(token))
            line += 1
    
    # Plot data onto the same axis'
    def plotData(self, year, summer, winter, outFile):
        figure()
        plot(year, summer)
        plot(year, winter)
        legend(['Summer', 'Winter'])
        xlabel('Year')
        ylabel('Rainfall (5 Year Mean)')
        title('Summer and Winter rainfall across the UK')
        # save plot to disk.
        savefig(outFile, dpi=200, format='PDF')

    # Plot the data onto separate axis, using subplot.
    def plotDataSeparate(self, year, summer, winter, outFile):
        figure()
        subplot(2,1,1)
        plot(year, summer)
        ylabel('Rainfall (5 Year Mean)')
        title('Summer rainfall across the UK')
        axis('tight')

        subplot(2,1,2)
        plot(year, winter)
        xlabel('Year')
        ylabel('Rainfall (5 Year Mean)')
        title('Winter rainfall across the UK')
        axis('tight')
        # save plot to disk.
        savefig(outFile, dpi=200, format='PDF')
    
    def run(self):
        filename = 'ukweatheraverage.csv' 
        if os.path.exists(filename):
            year = list()
            summer = list()
            winter = list()
            try:
                dataFile = open(filename, 'r') 
            except IOError, e:
                print '\nCould not open file:\n', e
                return
            self.parseDataFile(dataFile, year, summer, winter)
            dataFile.close()
            self.plotData(year, summer, winter, "Rainfall_SinglePlot.pdf")
            self.plotDataSeparate(year, summer, winter, "Rainfall_MultiplePlots.pdf")
        else:
            print 'File \'' + filename + '\' does not exist.'
    
if __name__ == '__main__':
    obj = PlotRainfall()
    obj.run()
