#!/usr/bin/env python

# Import the system library
import sys
# Import the RIOS rat library.
from rios import rat
# Import the python Argument parser
import argparse
# Import the numpy library
import numpy

# A function to add a colour table.
def addClassNames(imageFile):
    histo = rat.readColumn(imageFile, "Histogram")
    className = numpy.empty_like(histo, dtype=numpy.dtype('a255'))
    className[...] = "NA"
    className[0] = "Other Vegetation"
    className[1] = "Low Woody Vegetation"
    className[2] = "Water"
    className[3] = "Sparse Vegetation"
    className[4] = "Tall Woody Vegetation"
    # Write the output column to the file.
    rat.writeColumn(imageFile, "ClassNames", className)

# This is the first part of the script to 
# be executed.
if __name__ == '__main__':
    # Create the command line options 
    # parser.
    parser = argparse.ArgumentParser()
    # Define the argument for specifying the input file.
    parser.add_argument("-i", "--input", type=str, 
                        help="Specify the input image file.")
    # Call the parser to parse the arguments.
    args = parser.parse_args()
    
    # Check that the input parameter has been specified.
    if args.input == None:
        # Print an error message if not and exit.
        print "Error: No input image file provided."
        sys.exit()
        
    # Run the add class names function
    addClassNames(args.input)
